/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// CMNpGNXeV (for Delphi)
//

library cmn_***;

// K{wb_t@C
uses
  SysUtils,
  Windows,
  ComObj,
  Classes,
  cpxsdk;

{$E cpx}


//
//
// {ZNV
//

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// GNXeVpNX` (ICpxh)
//
type

	TMyCpx = class (TObject, ICpx)

	public
	constructor Create;						// RXgN^
	destructor Destroy; override;			// fXgN^

	protected
	//----------------------------------------------------------------
	// IUknown (COM̊{C^[tF[X)
	//
	function QueryInterface(const iid: TGUID; out ppv): HResult; virtual; stdcall;									// C^[tF[X₢킹
	function _AddRef: Integer; virtual; stdcall;																	// QƃJE^CNg
	function _Release: Integer; virtual; stdcall;																	// QƃJE^fNg

	//----------------------------------------------------------------
	// 
	//
	procedure cpxGetExtInfoBase (var ExtInfoBase: TExtInfoBase); virtual; stdcall;     								// GNXeV{擾

	//----------------------------------------------------------------
	// tH_vpeBp
	//
	procedure cpxGetExtInfoProp(var ExtInfoProp: TExtInfoProp) ; virtual; stdcall;									// tH_vpeB擾
	function  cpxGetFolderDetailItem(idxItem: Integer; var ExtFolderDetail: TExtInfoDetail): LongBool; virtual; stdcall;// tH_ڍ׏擾
	function  cpxGetBBSDetailItem(idxItem: Integer; var ExtBBSDetail: TExtInfoDetail): LongBool; virtual; stdcall;	// fڍ׏擾
	function  cpxGetFolderDetailText(pICmnPilot: ICmnPilot; hWndParent: HWND;
                                		lpszKey: LPSTR; lpszData: LPSTR): LongBool; virtual; stdcall;				// 擾 (ڍ)
	function  cpxGetBBSDetailText(pICmnPilot: ICmnPilot; hWndParent: HWND; idxBBS: Integer;
    								lpszKey: LPSTR; lpszData: LPSTR): LongBool; virtual; stdcall;					// fڍו擾
	function  cpxGetTarget(pICmnPilot: ICmnPilot; hWndParent: HWND; hWndTarget: HWND): LongBool; virtual; stdcall;	// ΏۑI
	function  cpxGetFuncMenu(pICmnPilot: ICmnPilot; idxBBS: Integer; const Mes: TMes; pFuncMenu: PTFuncMenuArray): 
								LongBool; virtual; stdcall;															// @\j[擾
	function  cpxWriteEditForm (pICmnPilot: ICmnPilot; idxBBS: Integer; const pMes: PTMes; bEditMes: LongBool;
									lpSourceFormBuf: LPCSTR; lpDestFormPath: LPCSTR): LongBool; virtual; stdcall;	// tH[GfB^ptH[쐬

	//----------------------------------------------------------------
	// p
	//
	function  cpxPilotStart(pICmnPilot: ICmnPilot): LongBool; virtual; stdcall;										// Jn
	procedure cpxPilotEnd(pICmnPilot: ICmnPilot); virtual; stdcall;													// I
	function  cpxFolderPilotStart(pICmnPilot: ICmnPilot): LongBool; virtual; stdcall;								// tH_Jn
	procedure cpxFolderPilotEnd(pICmnPilot: ICmnPilot); virtual; stdcall;											// tH_I
	function  cpxBBSPilotStart(pICmnPilot: ICmnPilot; idxBBS: Integer): LongBool; virtual; stdcall;					// fJn
	procedure cpxBBSPilotEnd; virtual; stdcall;																		// fI
	procedure cpxGetReceivedMesCount(var cDay: Integer; var cMes: Integer; reserved: Pointer); virtual; stdcall;	// Mςݔ擾
	procedure cpxGetReadURL(bForDisp: LongBool; lpszURL: LPSTR); virtual; stdcall;									// MURL쐬
	function  cpxReceiveMes: LongBool; virtual; stdcall;															// M
	function  cpxSendMes(const Mes: TMes): LongBool; virtual; stdcall;												// e
	function  cpxExecFunc(const Mes: TMes; wFunc: WORD): LongBool; virtual; stdcall;								// @\s

	//----------------------------------------------------------------
	// QƃJE^
	private
	m_cRef: Integer;						// QƃJE^

	end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// CX^X
//
// p[^
//   IUnknown *pICMN : CMÑC^[tF[X (in)
//   TMyCpx **ppv    : MyCpx̃C^[tF[X|C^ (out)
//
// ߂l
//   S_OK : 
//
// --------------------------------------------------------------------------------------
//
// - {IɌŒ
//
function cpxCreateInstance (out ppv: TMyCpx): HResult; stdcall;
begin;

	ppv := TMyCpx.Create();	// MyCpx𐶐 (_AddRef͂Ȃ)
	Result := S_OK;
end;

exports
	cpxCreateInstance;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MyCpx̃RXgN^
//
// QƃJE^͕̏K{łB
//
constructor TMyCpx.Create ();
begin
	inherited Create;

	m_cRef := 0;			// QƃJE^

	//#################################################################
	// Kv΂ɃNX̏Lq
	//


end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MyCpx̃fXgN^
//
destructor TMyCpx.Destroy;
begin
	//#################################################################
	// Kv΂ɃNX̌㏈Lq
	//
	
	
    inherited Destroy;

end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// C^[tF[X₢킹
//
// p[^
//   const IID& iid : GUID (in)
//   void **ppv     : C^[tF[X|C^ (out)
//
// ߂l
//   S_OK : C^[tF[X / E_NOINTERFACE : C^[tF[XȂ
//
// --------------------------------------------------------------------------------------
//
// - {IɌŒ
//
function TMyCpx.QueryInterface(const IID: TGUID; out ppv): HResult; stdcall;
begin
	// IIDɑΉC^[tF[Xݒ

	if GetInterface(IID,ppv) then
	begin
		Result := S_OK;
    	IUnknown (ppv)._AddRef;		// QƃJEgCNg
	end
	else
	begin
		Result := E_NOINTERFACE;
	end

end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// QƃJE^CNg
//
// ߂l
//   QƃJE^̒l
//
function TMyCpx._AddRef: Integer; stdcall;
begin
	Result := InterlockedIncrement (m_cRef);	 // QƃJE^CNg
end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// QƃJE^fNg
//
// ߂l
//   QƃJE^̒l
//
function TMyCpx._Release: Integer; stdcall;
begin
	if (InterlockedDecrement (m_cRef) = 0) then		// QƃJE^fNg
	begin
		Free;										// JEg0ɂȂCX^XJ
		Result := 0;
	end
	else
		Result := m_cRef;

end;

//
//
// vpeBZNV
//

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// GNXeV{擾
//
// p[^
//   tExtInfoBase *pExtInfoBase : GNXeV{ (out)
//
procedure TMyCpx.cpxGetExtInfoBase (var ExtInfoBase: TExtInfoBase); stdcall;
begin
	//#################################################################
	// tExtInfoBaseɃGNXeV̊{ݒ肷
	//
	ExtInfoBase.idExtType := EXTTYPE_PILOT;		// GNXeV^Cv (Œ)
	ExtInfoBase.dwSDKVer := CPXSDK_VERSION;		// CPXSDK̃o[W (Œ)
	StrCopy (ExtInfoBase.szReqVer, '*****');	// vCMÑo[W
end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// tH_vpeB擾
//
// p[^
//   tExtInfoProp *pExtInfoProp : tH_vpeB (out)
//
procedure TMyCpx.cpxGetExtInfoProp (var ExtInfoProp: TExtInfoProp); stdcall;
begin
	//#################################################################
	// tH_vpeBݒ肷
	//
	// GNXeV
	StrCopy (ExtInfoProp.szCaption, '******');		// Ώیf
	StrCopy (ExtInfoProp.szVersion, '******');		// CPX̃o[W
	StrCopy (ExtInfoProp.szCreator, '******');		// 쐬
	StrCopy (ExtInfoProp.szComment, '******');		// Rg
	ExtInfoProp.bTarget := ***;						// Ώە\tO
	ExtInfoProp.bTargetSelect := ***;				// ΏۑI{^\tO
	ExtInfoProp.idStrCode := ***;					// eR[h
	ExtInfoProp.idNewMes := ***;					// VID
	ExtInfoProp.bAutoBBSID := ***;					// BBSIDݒ
	ExtInfoProp.bSingleThread := ***;				// VOXbh[h
end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// fڍ׏擾
//
// p[^
//   idxItem        : \ڂ̃CfbNX (0x[X) (in)
//   pExtDetailItem : [ڍ] (out)
//
// ߂l
//   ݒ肵 : TRUE / ݒ肵Ȃ : FALSE
//
// --------------------------------------------------------------------------------------
//
// - tH_vpeBڍׂݒ肷
// - \͊{IɌŒ
// - ڎʂ͈ȉ̒ʂ
//   - IK_STRING   : 
//   - IK_TEXT     : eLXg
//   - IK_TEXTB    : eLXg({^t/ړ͉)
//   - IK_TEXTR    : eLXg([hI[)
//   - IK_TEXTRB   : eLXg({^t/ړ͕s1)
//   - IK_CHECKBOX : `FbN{bNX
//   - IK_RADIO    : WI{^
//   - IK_FILER    : t@CI(Q)
//   - IK_FILEW    : t@CI(쐬)
//   - IK_COLOR    : FI
// - ȉ̍ڎʂŃCfgݒ\
//   - IK_INDENTR  : EɃCfg
//   - IK_INDENTL  : ɃCfg
//
function  TMyCpx.cpxGetBBSDetailItem(idxItem: Integer; var ExtBBSDetail: TExtInfoDetail): LongBool; stdcall
	var cItem: Integer;
begin
	//#################################################################
	// ڍ׏񂪂ꍇ͂ɋLq
	//

	Result := False;
end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// tH_ڍ׏擾
//
// p[^
//   idxItem        : \ڂ̃CfbNX (0x[X) (in)
//   pExtDetailItem : [ڍ] (out)
//
// ߂l
//   ݒ肵 : TRUE / ݒ肵Ȃ : FALSE
//
// --------------------------------------------------------------------------------------
//
// - tH_vpeBڍׂݒ肷
// - \͊{IɌŒ
// - ڎʂ͈ȉ̒ʂ
//   - IK_STRING   : 
//   - IK_TEXT     : eLXg
//   - IK_TEXTB    : eLXg({^t/ړ͉)
//   - IK_TEXTR    : eLXg([hI[)
//   - IK_TEXTRB   : eLXg({^t/ړ͕s1)
//   - IK_CHECKBOX : `FbN{bNX
//   - IK_RADIO    : WI{^
//   - IK_FILER    : t@CI(Q)
//   - IK_FILEW    : t@CI(쐬)
//   - IK_COLOR    : FI
// - ȉ̍ڎʂŃCfgݒ\
//   - IK_INDENTR  : EɃCfg
//   - IK_INDENTL  : ɃCfg
//
function  TMyCpx.cpxGetFolderDetailItem(idxItem: Integer; var ExtFolderDetail: TExtInfoDetail): LongBool; stdcall
begin
	//#################################################################
	// ڍ׏񂪂ꍇ͂ɋLq
	//
	
	
	Result := False;
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ΏۑI
//
// p[^
//   pICmnPilot: ICmnPilot; CMÑC^[tF[X (in)
//   hWndParent: HWND;      tH_vpeB̃EBhEnh (in)
//   hWndTarget: HWND;      Ώۓ̓GÃEBhEnh (in)
//
// ߂l
//   TRUE : Ώۂݒ肵 / FALSE : Ώۂݒ肵Ȃ
//
// --------------------------------------------------------------------------------------
//
// - tH_vpeB[tH_]ŏΏۂ́uI{^vꂽ̓Lq
// - SetWindowText  hWndTarget ɕݒ
//
function  TMyCpx.cpxGetTarget (pICmnPilot: ICmnPilot; hWndParent: HWND; hWndTarget: HWND): LongBool; stdcall;
begin
	//#################################################################
	//uI{^vꂽ̓Lq
	//


	Result := False;
end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// fڍ׏ڍו擾
//
// p[^
//   pICmnPilot : CMÑC^[tF[X (in)
//   hWndText   : ݒ肷EBhẼnh (in)
//   idxBBS     : fCfbNX (0x[X) (in)
//   pszKey     : ڂ̃L[ (in)
//   pszData    : ڂ̒l (300byte) (in/out)
//
// ߂l
//   TRUE : ݒ肵 / FALSE : ݒ肵Ȃ
//
// --------------------------------------------------------------------------------------
//
// - tH_vpeB[ڍ]ŃeLXg͂̃{^ꂽ̓Lq
// - pszData ɕݒ
//
function  TMyCpx.cpxGetBBSDetailText(pICmnPilot: ICmnPilot; hWndParent: HWND; idxBBS: Integer; lpszKey: LPSTR; lpszData: LPSTR): LongBool; stdcall;
begin
	//#################################################################
	// eLXg͂̃{^ꂽ̓Lq
	//


	Result := False;
end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// tH_ڍו擾
//
// p[^
//   pICmnPilot : CMÑC^[tF[X (in)
//   hWndText   : ݒ肷EBhẼnh (in)
//   pszKey     : ڂ̃L[ (in)
//   pszData    : ڂ̒l (300byte) (in/out)
//
// ߂l
//   TRUE : ݒ肵 / FALSE : ݒ肵Ȃ
//
// --------------------------------------------------------------------------------------
//
// - tH_vpeB[ڍ]ŃeLXg͂̃{^ꂽ̓Lq
// - pszData ɕݒ
//
function  TMyCpx.cpxGetFolderDetailText(pICmnPilot: ICmnPilot; hWndParent: HWND; lpszKey: LPSTR; lpszData: LPSTR): LongBool; stdcall;
begin
	//#################################################################
	// eLXg͂̃{^ꂽ̓Lq
	//


	Result := False;
end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// @\j[擾
//
// p[^
//   pICmnPilot : CMÑC^[tF[X (in)
//   idxBBS     : fCfbNX(0x[X)/f񂪂Ȃꍇ -1 (in)
//   pMes       : f[^ (in)
//   pFuncMenu  : ǉ@\j[̕ (out)
//
// ߂l
//   TRUE : ǉ@\j[
//   FALSE : ǉ@\j[Ȃ
//
function TMyCpx.cpxGetFuncMenu (pICmnPilot: ICmnPilot; idxBBS: Integer; const Mes: TMes; pFuncMenu: PTFuncMenuArray): LongBool; stdcall;
begin
	//#################################################################
	// ǉj[ݒ
	//

	Result := FALSE;
end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// tH[GfB^ptH[쐬
// p[^
//   pICmnPilot      : CMÑC^[tF[X (in)
//   idxBBS          : fCfbNX(0x[X)/f񂪂Ȃꍇ -1 (in)
//   bEditMes;       : ĕҏW̏ꍇTRUE/ȊOFALSE (in)
//   pMes            : ԐM攭f[^܂͕ҏWf[^/ȊONULL (in)
//   lpSourceFormBuf : JX^}CYtH[̈/ȂNULL (in)
//   lpDestFormPath  : o͐tH[̃pX (in)
//
// ߂l
//   TRUE : tH[𐶐
//   FALSE : tH[𐶐ĂȂ
//
function  TMyCpx.cpxWriteEditForm (pICmnPilot: ICmnPilot; idxBBS: Integer; const pMes: PTMes; bEditMes: LongBool;
									lpSourceFormBuf: LPCSTR; lpDestFormPath: LPCSTR): LongBool; stdcall;
begin
	//#################################################################
	// tH[쐬܂̓JX^}CYꍇ͂ɋLqTRUE߂
	// idxBBS-1̎̂Œ
	//


	Result := False;
end;


//
//
// ZNV
//

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Jn
//
// p[^
//   pICmnPilot: ICmnPilot; CMÑC^[tF[X (in)
//
// --------------------------------------------------------------------------------------
//
// - ŏɂ̃GNXeVŏ񂳂鎞ɃR[
//
function TMyCpx.cpxPilotStart (pICmnPilot: ICmnPilot): LongBool; stdcall;
begin
	//#################################################################
	// ɏ񂳂镡̃tH_ɋʂĂP̂ݎs鏈Lq
	//

	Result :=TRUE;
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// I
//
// p[^
//   pICmnPilot: ICmnPilot; CMÑC^[tF[X (in)
//
// --------------------------------------------------------------------------------------
//
// - IɃR[
//
procedure TMyCpx.cpxPilotEnd (pICmnPilot: ICmnPilot); stdcall;
begin
	//#################################################################
	// ɏ񂳂镡̃tH_ɋʂĂP̂ݎs鏈Lq
	//

end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// tH_Jn
//
// p[^
//   pICmnPilot: ICmnPilot; CMÑC^[tF[X (in)
//
// ߂l
//   TRUE :  / FALSE : s
//
// --------------------------------------------------------------------------------------
//
// - tH_̏JnɃR[
//
function TMyCpx.cpxFolderPilotStart (pICmnPilot: ICmnPilot): LongBool; stdcall;
begin
	//#################################################################
	// tHǔ̕fɋʂĂP̂ݎs鏈Lq
	//

	Result := TRUE;
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// tH_I
//
// p[^
//   pICmnPilot: ICmnPilot; CMÑC^[tF[X (in)
//
// --------------------------------------------------------------------------------------
//
// - tH_̏IɃR[
// - ef̏Ƃ͕ʃCX^X
//
procedure  TMyCpx.cpxFolderPilotEnd (pICmnPilot: ICmnPilot); stdcall;
begin
	//#################################################################
	// tHǔ̕fɋʂĂP̂ݎs鏈Lq
	//
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// fJn
//
// p[^
//   pICmnPilot: ICmnPilot; CMÑC^[tF[X (in)
//   idxBBS: Integer;       fCfbNX (0x[X) (in)
//
// --------------------------------------------------------------------------------------
//
// - f̏JnɃR[
//
function TMyCpx.cpxBBSPilotStart (pICmnPilot: ICmnPilot; idxBBS: Integer): LongBool; stdcall;
begin



	Result := TRUE;
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// fI
//
// --------------------------------------------------------------------------------------
//
// - f̏IɃR[
//
procedure TMyCpx.cpxBBSPilotEnd; stdcall;
begin



end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ߋ擾
//
// p[^
//   pcDay: Integer *;  擾
//   pcMes: Integer *;  擾
//
procedure  TMyCpx.cpxGetReceivedMesCount (var cDay: Integer; var cMes: Integer; reserved: Pointer); stdcall;
begin
	//#################################################################
	// Mςݔ擾ꍇɂ͂̌ݒ
	//


end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MURL쐬
//
// p[^
//   pICmnPilot: ICmnPilot; CMÑC^[tF[X (in)
//   idxBBS: Integer;       fCfbNX (0x[X) (in)
//   bForDisp: LongBool;     \p (in)
//   pszURL: LPSTR;         MURL (out)
//
// --------------------------------------------------------------------------------------
//
// - 
//
procedure  TMyCpx.cpxGetReadURL (bForDisp: LongBool; lpszURL: LPSTR); stdcall;
begin
	//#################################################################
	// MURL쐬
	//


end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// M
//
// ߂l
//   TRUE :  / FALSE : s
//
// --------------------------------------------------------------------------------------
//
// - MLq
//
function  TMyCpx.cpxReceiveMes (): LongBool; stdcall;
begin
	//#################################################################
	// MLq
	//


	Result := TRUE;
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// e
//
// p[^
//   pMes: const tMes *; ef[^ (in)
//
// ߂l
//   TRUE :  / FALSE : s
//
// --------------------------------------------------------------------------------------
//
// - eLq
//
function  TMyCpx.cpxSendMes (const Mes: TMes): LongBool; stdcall;
begin
	//#################################################################
	// eLq
	//

	Result := TRUE;
end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// @\s
//
// p[^
//   tMes *pMes : f[^
//   DWORD flag : @\tO
//
// ߂l
//   TRUE :  / FALSE : s
//
// --------------------------------------------------------------------------------------
//
// - Ȃꍇ TRUE ߂
//
function TMyCpx.cpxExecFunc (const Mes: TMes; wFunc: Word): LongBool; stdcall;
begin
	//#################################################################
	// @\Lq
	//

	Result := TRUE;
end;



end.


